#ifndef __GEOMETRYSET_H__
#define __GEOMETRYSET_H__

#include <set>

#include "refcount.h"

namespace xrt
{
	class GeometricPrimitive;

	struct less: public std::binary_function< Reference< GeometricPrimitive >, Reference< GeometricPrimitive >, bool >
	{	// functor for operator<
		bool operator()( const Reference< GeometricPrimitive >& a, const Reference< GeometricPrimitive >& b ) const
		{	// apply operator< to operands
			return a.get() < b.get();
		}
	};

	typedef std::set< Reference< GeometricPrimitive >, less > GeometrySet;
}

#endif //__GEOMETRYSET_H__