#ifndef __RWMUTEX_H__
#define __RWMUTEX_H__

#include "sys/platform.h"

namespace sys
{
  /*! r/w mutex */
  class __public RWMutex 
  {
  public:
   RWMutex( void );
   ~RWMutex( void );
    void lockRead   ( void );
    void unlockRead ( void );
    void lockWrite   ( void );
    void unlockWrite ( void );
  protected:
	void *mutex;
    RWMutex( const RWMutex& ); // don't implement
    RWMutex& operator =( const RWMutex& ); // don't implement
  };

  enum RWMutexLockType { READ, WRITE };

  struct __public RWMutexLock 
  {
    RWMutexLock(RWMutex &m, RWMutexLockType t);
    ~RWMutexLock();
    void upgradeToWrite();
    void downgradeToRead();
  private:
    RWMutexLockType type;
    RWMutex &mutex;
    RWMutexLock(const RWMutexLock &);
    RWMutexLock &operator=(const RWMutexLock &);
  };

}

#endif
