surface
aff (color ambientcolor = 0.1;
     color specularcolor = 0;
     float roughness = .1;
     float transmitted = 0.;
     float index = 1.0;
     string texturename = ""; )
{
	normal Nn = faceforward (normalize(N),I);
	normal In = normalize( I );
	color reflected, refracted;

	if ( ( comp( specularcolor, 0 ) > .001 ) || ( comp( specularcolor, 1 ) > .001 ) || ( comp( specularcolor, 2 ) > .001 ) ) 
	{
		reflected = specularcolor * color trace (P, reflect(I, Nn));
	}
	if ( transmitted > .001 ) 
	{
		vector T = refract(In, Nn, (N.I)>0 ? index : 1/index ); 
		if ( length( T ) != 0.0 )
			refracted = transmitted * color trace (P, T);
	}

	Oi = Os;
	
	Ci = Os * ( ambientcolor * ambient() +  Cs * diffuse(Nn) + reflected + refracted
		+ specularcolor * phong( Nn, -In, roughness ) );
		
	if ( texturename != "" )
		Ci *= color texture( texturename );
}