surface hair (float Ka = 1, Kd = .6, Ks = .15, roughness = .025;
	color rootcolor = color (.109, .037, .007);
	color tipcolor = color (.519, .325, .125);
)
{
	vector T = normalize (dPdv); /* tangent along length of hair */
	vector V = -normalize(I); /* V is the view vector */
	color specularcolor = color(1);
	color Cspec = 0, Cdiff = 0; /* collect specular & diffuse light */

	/* Loop over lights, catch highlights as if this was a thin cylinder */
	illuminance (P) {
		float theta = acos (T . normalize(L));
			// diffuse component
		float diff = sin(theta);
			// specular component
		float cosang = cos (abs (theta - acos (-T.V)));
		float spec = pow (cosang, 1/roughness);
		Cspec += Cl * spec;
		Cdiff += Cl * diff;
	}

	Oi = Os;
	Ci = Oi * (mix(rootcolor, tipcolor, v*v) * (Ka*ambient() + Kd*Cdiff)
	+ (Ks * Cspec * specularcolor));
}
