/* $Id$  (Pixar - RenderMan Division)  $Date$ */
/*
** Copyright (c) 2002 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1200 Park Avenue
** Emeryville, CA 94608
*/
light
indirectlight(
    float samples = 64;
    string environmentmap = "";
    color filter = color(1);
    float coneangle = radians(180);
    output float __nonspecular = 1;
    )
{
    uniform point from = point "shader" (0,0,0);
    uniform vector toward = vector "shader" (0,0,1);

    illuminate( from, toward, coneangle ) {
        normal Nn = faceforward(normalize(N),I);
	Cl = filter * indirectdiffuse(Ps, Nn, samples,
				      "environmentmap", environmentmap);
        L = -Nn;
    }
}
