/*-*-C++-*------------------------------------------------------------------
 * gaol -- NOT Just Another Interval Library
 *--------------------------------------------------------------------------
 * This file is part of the gaol distribution. It has been developed at the
 * Laboratoire d'Informatique de Nantes-Atlantique (FRE CNRS 2729), France
 * 
 * Copyright (c) 2001-2006 Laboratoire d'Informatique de Nantes-Atlantique
 *--------------------------------------------------------------------------
 * gaol is a software distributed WITHOUT ANY WARRANTY. Read the associated 
 * COPYING file for information.
 *--------------------------------------------------------------------------
 * CVS: $Id: gaol_assert.h,v 1.1 2006/02/21 12:29:43 goualard Exp $
 * Last modified: Tue Feb 21 09:59:49 2006 on caleb
 * By: Frederic Goualard <Frederic.Goualard@lina.univ-nantes.fr>
 *--------------------------------------------------------------------------*/

/*!
  \file   gaol_assert.h
  \brief  Assertions

  <long description>

  \author Frederic Goualard
  \date   2006-02-21
*/


#ifndef __gaol_assert_h__
#define __gaol_assert_h__

#include "gaol/gaol_config.h"

  // Assertions
#if GAOL_DEBUGGING
# if HAVE_CASSERT
#   include <cassert>
#   undef NDEBUG
#   define GAOL_ASSERT(a) assert(a)
# else
#   include <cstdlib>
#   define GAOL_ASSERT(a) if (!(a)) abort()
# endif // HAVE_CASSERT
#else 
# define GAOL_ASSERT(a) 
#endif  // GAOL_DEBUGGING


#endif /* __gaol_assert_h__ */
