/*-*-C++-*------------------------------------------------------------------
 * gaol -- Just Another Interval Library
 *--------------------------------------------------------------------------
 * This file is part of the gaol distribution. Gaol was primarily 
 * developed at the Swiss Federal Institute of Technology, Lausanne, 
 * Switzerland, and is now developed at the Institut de Recherche 
 * en Informatique de Nantes, France.
 *
 * Copyright (c) 2001 Swiss Federal Institute of Technology, Switzerland
 * Copyright (c) 2002 Institut de Recherche en Informatique de Nantes, France
 *--------------------------------------------------------------------------
 * gaol is a software distributed WITHOUT ANY WARRANTY. Read the associated 
 * COPYING file for information.
 *--------------------------------------------------------------------------
 * CVS: $Id: gaol_double_op.h,v 1.10 2006/03/22 08:35:12 goualard Exp $
 * Last modified: Tue Feb 21 16:14:45 2006 on caleb
 * By: Frederic Goualard <Frederic.Goualard@lina.univ-nantes.fr>
 *--------------------------------------------------------------------------*/

/*!
  \file   gaol_double_op.h
  \brief  Operations correctly rounded down and up.

  This is a front-end to both various versions of the operators

  \author Frdric Goualard
  \date   2001-10-03
*/


#ifndef __gaol_double_op_h__
# define __gaol_double_op_h__

#ifdef GAOL_FAST_MATH
# include "gaol/gaol_double_op_fast.h"
#else
# include "gaol/gaol_double_op_precise.h"
#endif

#endif /* __gaol_double_op_h__ */
