/*-*-C++-*------------------------------------------------------------------
 * gaol -- Just Another Interval Library
 *--------------------------------------------------------------------------
 * This file is part of the gaol distribution. Gaol was primarily 
 * developed at the Swiss Federal Institute of Technology, Lausanne, 
 * Switzerland, and is now developed at the Institut de Recherche 
 * en Informatique de Nantes, France.
 *
 * Copyright (c) 2001 Swiss Federal Institute of Technology, Switzerland
 * Copyright (c) 2002 Institut de Recherche en Informatique de Nantes, France
 *--------------------------------------------------------------------------
 * gaol is a software distributed WITHOUT ANY WARRANTY. Read the associated 
 * COPYING file for information.
 *--------------------------------------------------------------------------
 * CVS: $Id: gaol_flags.h,v 1.4 2006/03/22 08:35:12 goualard Exp $
 * Last modified: Mon Oct 21 11:10:03 2002 on victory.irin.sciences.univ-nantes.fr
 * By: Frederic Goualard <Frederic.Goualard@irin.univ-nantes.fr>
 *--------------------------------------------------------------------------*/

/*!
  \file   gaol_flags.h
  \brief  

  <long description>

  \author Frdric Goualard
  \date   2001-10-30
*/


#ifndef __gaol_flags_h__
#define __gaol_flags_h__

namespace gaol {


  /*!
    \brief Type for priority of operators in expressions
   */
  class prec_t {
  public:
    enum { 
      null_prec   =  0, // null node
      plus_prec   =  2, // +, -, 
      mult_prec   =  5, // *, /
      uminus_prec =  6, // unary minus, pow, 
      cst_prec    = 10  // constant, variable, sine, cosine, ...
    };
  };

} // namespace gaol

#endif /* __gaol_flags_h__ */
