/*-*-C++-*------------------------------------------------------------------
 * gaol -- Just Another Interval Library
 *--------------------------------------------------------------------------
 * This file is part of the gaol distribution. Gaol was primarily 
 * developed at the Swiss Federal Institute of Technology, Lausanne, 
 * Switzerland, and is now developed at the Institut de Recherche 
 * en Informatique de Nantes, France.
 *
 * Copyright (c) 2001 Swiss Federal Institute of Technology, Switzerland
 * Copyright (c) 2002 Institut de Recherche en Informatique de Nantes, France
 *--------------------------------------------------------------------------
 * gaol is a software distributed WITHOUT ANY WARRANTY. Read the associated 
 * COPYING file for information.
 *--------------------------------------------------------------------------
 * CVS: $Id: gaol_fpu.h,v 1.10 2006/03/22 08:35:12 goualard Exp $
 * Last modified: Tue Mar 21 15:25:23 2006 on pc-dubreil-123.irin.sciences.univ-nantes.prive
 * By: Frederic Goualard <Frederic.Goualard@lina.univ-nantes.fr>
 *--------------------------------------------------------------------------*/

/*!
  \file   gaol_fpu.h
  \brief  

  <long description>

  \author Frdric Goualard
  \date   2001-10-01
*/


#ifndef __gaol_fpu_h__
#define __gaol_fpu_h__

// To overcome problems with old versions of autoconf
#undef PACKAGE
#include "gaol/gaol_config.h"

#if (IX86_LINUX || IX86_CYGWIN)
#  include "gaol/sysdeps/gaol_fpu_ix86.h"
#elif SPARC_SOLARIS
#  include "gaol/sysdeps/gaol_fpu_sparc.h"
#elif defined (_MSC_VER)
#  include "gaol/sysdeps/gaol_fpu_msvc.h"
#elif POWERPC_UNIX
#  include "gaol/sysdeps/gaol_fpu_powerpc.h"
#else
# error "unsupported platform"
#endif

#if GAOL_TRUST_ROUNDING
#  define GAOL_RND_UP()
#else
#  define GAOL_RND_UP() round_upward()
#endif


#endif /* __gaol_fpu_h__ */
